import java.util.Arrays;

import org.jaudiolibs.beads.AudioServerIO;

import net.beadsproject.beads.analysis.featureextractors.FFT;
import net.beadsproject.beads.analysis.featureextractors.PowerSpectrum;
import net.beadsproject.beads.analysis.segmenters.ShortFrameSegmenter;
import net.beadsproject.beads.core.AudioContext;
import net.beadsproject.beads.core.AudioIO;
import net.beadsproject.beads.core.UGen;
import net.beadsproject.beads.ugens.Gain;
import processing.core.PApplet;


public class BeadsJNA extends PApplet {
	
	AudioContext ac;
	ShortFrameSegmenter sfs;
	PowerSpectrum ps;
	
	public void setup(){
		ac = new AudioContext(new AudioServerIO.Jack(),512,AudioContext.defaultAudioFormat(6,6));
//		ac = new AudioContext(new AudioServerIO.Jack());
		
//		UGen microphoneIn = ac.getAudioInput(new int[]{1,2,3,4});
		UGen microphoneIn = ac.getAudioInput();
		Gain g = new Gain(ac, 1, 0.5f);
		g.addInput(microphoneIn);
		ac.out.addInput(g);
		
		println("no. of inputs:  " + ac.getAudioInput().getOuts()); 
		
		sfs = new ShortFrameSegmenter(ac);
		sfs.addInput(ac.out);
		FFT fft = new FFT();
		sfs.addListener(fft);
		ps = new PowerSpectrum();
		fft.addListener(ps);
		ac.out.addDependent(sfs);
		
		ac.start();
	}
	public void draw(){
		/*
		loadPixels();
		  Arrays.fill(pixels, color(0));
		  
		  for(int i = 0; i < width; i++)
		  {
		    int buffIndex = i * ac.getBufferSize() / width;
		    int vOffset = (int)((1 + ac.out.getValue(0, buffIndex)) * height / 2);
		    pixels[vOffset * height + i] = color(255);
		  }
		  updatePixels();
		  //*/
		background(255);
		float[] features = ps.getFeatures();
		if(features != null){
			for(int x = 0; x < width; x++){
		      int featureIndex = (x * features.length) / width;
		      int barHeight = Math.min((int)(features[featureIndex] *
		                                        height), height - 1);
		      line(x, height, x, height - barHeight);
			} 
		}
	}
	
	public static void main(String[] args) {
		PApplet.main(BeadsJNA.class.getSimpleName());
	}

}
